/* hwmgr.c
 * This is just a little module to manage our
 * "hardware". IE: There are three levels of hardware: 
 *    -- packet generation 
 *    -- protocol
 *    -- physical
 * Each level has a name and routines associated with it. 
 */

#include<stdlib.h>
#include"network.h"
#include"hwmgr.h"

/* Packet sources */
#include"pksource.h"

/* Protocols */
#include"magicnet.h"
#include"dsr.h"

/* Mediums */
#include"magicmedium.h"
#include"wireless.h"
#include"wire.h"

HWNODECAP g_hwNodeCapSrv[] = {
  { "None", NULL, NULL, NULL },
  { "Constant Stream", psCSInitNodeCap, psCSTickNodeCap, psCSKillNodeCap },
  { "Event", psEventInitNodeCap, psEventTickNodeCap, psEventKillNodeCap },
  { "MultiCon", psMultiInitNodeCap, psMultiTickNodeCap, psMultiKillNodeCap },
  { NULL, NULL, NULL, NULL }
};

HWNODE g_hwNodeSrv[] = {
  { "Magic Protocol", mnMagicInitNode, mnMagicTickNode, mnMagicKillNode, 
       mnMagicRcvPacket, mnMagicDeliveryError }, 
  { "DSR", dsrInitNode, dsrTickNode, dsrKillNode,
       dsrRcvPacket, dsrDeliveryError },
  { "None", NULL, NULL, NULL, NULL, NULL },
  { NULL, NULL, NULL, NULL, NULL, NULL }
};

HWMEDIUM g_hwMediumSrv[] = {
  { "Magic Medium", maMagicInitMedium, maMagicTickMedium, maMagicKillMedium, 
     maMagicKillInterface, maMagicSendPacket, NULL },
  { "Wireless", wtWirelessInitMedium, wtWirelessTickMedium, 
     wtWirelessKillMedium, wtWirelessKillInterface, wtWirelessSendPacket,
     wtWirelessMinHop },
  { "Wire", wmWireInitMedium, wmWireTickMedium, 
     wmWireKillMedium, wmWireKillInterface, wmWireSendPacket,
     NULL },
  { "None", NULL, NULL, NULL, NULL, NULL, NULL },
  { NULL, NULL, NULL, NULL, NULL, NULL, NULL }
};

