/* Magic Network Facilities */

/* #define MNDEBUG */

#include<stdio.h>
#include<stdlib.h>
#include"memmgr.h"
#include"network.h"
#include"magicnet.h"


void mnMagicInitNode(NWNODE *p_Node) {
#ifdef MNDEBUG
  printf("MagicNet: Init Node %li\n",p_Node->nNodeCap->nID);
#endif
  return;
}

void mnMagicTickNode(NWNODE *p_Node) {
  NWPACKET *l_Packet,*l_OrigPk;
  NWINTERFACE *l_Int;
  long *l_Dest;

  mmuSanityCheck();
#ifdef MNDEBUG
  printf("MagicNet: Tick Node %li\n",p_Node->nNodeCap->nID);
#endif

   for (l_OrigPk=p_Node->nNodeCap->nPacketBuffer;
     l_OrigPk;
     l_OrigPk=l_OrigPk->pNext) {
    mmuSanityCheck();
    l_Packet=nwCopyPacket(l_OrigPk,0);
    mmuSanityCheck();
#ifdef MNDEBUG
    printf("MagicNet: Packet sent from %li to %li\n",l_Packet->pSourceID,
      l_Packet->pDestID);
#endif
    l_Packet->pDataLen=sizeof(long);
    l_Packet->pData=(void*)0x12345678;
    mmuSanityCheck();
    l_Packet->pData=mmuAlloc(sizeof(long));
    mmuSanityCheck();
    l_Dest=((long *)(l_Packet->pData));
    *l_Dest=l_Packet->pDestID;
    mmuSanityCheck();
    /* now fire the sucker off to the physical layer -- in this case, 
     * the first interface */
    for (l_Int=p_Node->nInterface;l_Int;l_Int=l_Int->iNodeNext) {
      mmuSanityCheck();
      if (p_Node->nInterface->iMedium->mSendPacket)
        (p_Node->nInterface->iMedium->mSendPacket)(p_Node->nInterface,
          l_Packet,l_Packet->pDestID);
      mmuSanityCheck();
    }
    nwFreePacket(l_Packet);
  }
  mmuSanityCheck();
}

void mnMagicKillNode(NWNODE *p_Node) {
#ifdef MNDEBUG
  printf("MagicNet: Kill Node %li\n",p_Node->nNodeCap->nID);
#endif
  return;
}

void mnMagicRcvPacket(NWINTERFACE *p_Interface,NWPACKET *p_Packet) {
  long *l_Dest;

  mmuSanityCheck();
  /*printf("MagicNet: RcvPacket from node %li to node %li(for %li), via medium %li\n",
    p_Packet->pSourceID,
    p_Interface->iNode->nNodeCap->nID,
    p_Packet->pDestID,
    p_Interface->iMedium->mID);
*/
  l_Dest=((long*)(p_Packet->pData));
  if (*l_Dest==p_Interface->iNode->nNodeCap->nID) {
    /* yay! we got the packet! */
    /*printf("Packet received at %li!\n",*l_Dest);*/
  }
  mmuSanityCheck();
}

void mnMagicDeliveryError(NWINTERFACE *p_Interface,NWPACKET *p_Packet, long p_ErrorCode) {
  mmuSanityCheck();
  /*printf("MagicNet: DELIVERY FAILED from node %li to node %li, via Int %li to %li, via medium %li",
    p_Packet->pSourceID,
    p_Packet->pDestID,
    p_Packet->pSourceIntID,
    p_Packet->pDestIntID,
    p_Interface->iMedium->mID);*/
  if (p_Packet->pDestIntID==NWADDR_BROADCAST) {
    /*printf("--KILLED\n");*/
  } else {
    /*printf("--Broadcasting\n");*/
    /* resubmit packet in broadcast mode */
    (p_Interface->iMedium->mSendPacket)(p_Interface,p_Packet,NWADDR_BROADCAST);
  }
  mmuSanityCheck();
}

