#ifndef _MEMMGR_H_
#define _MEMMGR_H_

/* uncomment this if you wish to enable memory debugging (somewhat) */
/* #define MMUENABLED */ 

#ifdef MMUENABLED
void mmuSanityCheck(void);
void *mmuAlloc(unsigned long p_Size);
void mmuFree(void *p_MemPtr);
void *mmuReAlloc(void *p_MemPtr, unsigned long p_NewSize);
unsigned long mmuGetSize(void *p_MemPtr);
void mmuPrintData(void);
int mmuVerifyPointer(void *p_MemPtr);

#else
#include<stdlib.h>
#define mmuSanityCheck() ;
#define mmuAlloc(x) malloc(x)
#define mmuFree(x) free(x)
#define mmuReAlloc(x,y) realloc(x,y)
#define mmuGetSize(x) 1
#define mmuPrintData() ;
#define mmuVerifyPointer(x) ;

#endif /* MMUDISABLED */

#endif /* _MEMMGR_H_ */
