/* Constants */
#define WT_STATUS_IDLE      0
#define WT_STATUS_RECEIVING 1
#define WT_STATUS_SENDING   2

/* Structures */
typedef struct WTINTERFACEDATA {
  long iTransmissionRadius; /* radius of transmission */
  NWPACKET *iPacketBuffer;  /* holds one packet -- waiting or being sent */
  long iNodePriority;       /* increases each time node has something to send but can't */
  long iNodeStatus;         /* idle, receiving, or sending */
  long iNodeCountDown;      /* when sending, cowntdown to when done */
  long iNodeCountVal;       /* Original cowntdown value */
  long iNodeCountUp;        /* # bytes received by this node */
  long iNodeRcvFromID;      /* interface ID of node we're receiving  */
  long iNodeSendHoldoff;    /* holdoff before sending */
  long iRetransmit;         /* # retransmissions left */
  long iTag;                /* for minimal route calculations */
} WTINTERFACEDATA;

typedef struct WTMEDIUMDATA {
  long mSomeVal;
} WTMEDIUMDATA;

/* Function prototypes */
void wtWirelessInitMedium(NWMEDIUM *p_Medium);
void wtWirelessTickMedium(NWMEDIUM *p_Medium);
void wtWirelessKillMedium(NWMEDIUM *p_Medium);
void wtWirelessKillInterface(NWINTERFACE *p_Interface);
unsigned long wtWirelessSendPacket(NWINTERFACE *p_Interface, NWPACKET *p_Packet, long p_DestinationID);
long wtWirelessMinHop(NWINTERFACE *p_SrcInt,long p_DstIntID);


